%define  libpuma    %mklibname puma -s
%define  libpuma_d  %mklibname puma -d

Name:           aspectc++
Version:        2.2
Release:        %mkrel 1
Summary:        Compiler for C++ language extension to support aspect orientation
License:        GPLv2+
Group:          Development/C
URL:            http://www.aspectc.org
Source0:        http://www.aspectc.org/releases/%{version}/ac-%{version}.tar.gz
Patch0:         aspectc++-2.2-upstream-fix-for-clang-3.9.1.patch
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(zlib)
BuildRequires:  clang-devel >= 3.9.1
BuildRequires:  llvm-static >= 3.9.1

%description
The AspectC++ compiler enables you to benefit from the aspect oriented
programming paradigm.

#----------------------------------------------------

%package -n %{libpuma_d}
Summary:    Libraries and header files for %{name}
Group:      Development/C
Requires:   %{name} = %{version}-%{release}
Provides:   puma-devel = %{version}-%{release}
Provides:   %{name}-devel = %{version}-%{release}
Obsoletes:  %{libpuma}

%description -n %{libpuma_d}
This package contains the static development libraries and headers needed
to compile applications linked with %{name} libraries. This package contains
only the stripped-down MiniPuma version of the library.

#----------------------------------------------------

%prep
%setup -q -n %{name}
%autopatch -p1

%build
%make_build -C Puma MINI=1
%make_build -C AspectC++ SHARED=1
%make_build -C Ag++ SHARED=1

%install
%make_install -C Puma PREFIX="%{buildroot}%{_prefix}" MINI=1
%if "%{?_lib}" == "lib64"
    mkdir -p %{buildroot}%{_libdir}
    mv %{buildroot}%{_prefix}/lib/* %{buildroot}%{_libdir}
    rm -frv  %{buildroot}%{_prefix}/lib
%endif
mkdir -p %{buildroot}%{_bindir}
install AspectC++/bin/linux-release/a[cg]++ %{buildroot}%{_bindir}

%check
# RepoInvalid and Bug570 tests fail for unknown reasons, maybe due to use of
# ag++ instead of ac++
# Note that test failures don't actually cause the make (and therefore the
# check) to fail, so this testing is of limited use
%__make -C AspectC++ testall AC="`pwd`/AspectC++/bin/linux-release/ag++" ACOPTFLAGS=--weave_only

%files -n %{libpuma_d}
%{_libdir}/libMiniPuma.a
%{_includedir}/Puma
%doc Puma/doc/UsersManual/UsersManual.pdf

%files
%{_bindir}/ac++
%{_bindir}/ag++
%doc AspectC++/doc/NoE_ExecModelSurvey/ac++exec-survey.pdf
#%%doc AspectC++/doc/LanguageReference/LanguageReference.pdf
%doc %lang(ru) AspectC++/doc/LanguageReference/ac-languageref-ru.pdf
%doc AspectC++/doc/NoE_ShortSurvey/ac++lang-survey.pdf
%doc AspectC++/doc/QuickRef/ac++quickref.pdf
#%%doc AspectC++/doc/CompilerManual/CompilerManual.pdf
%doc Ag++/doc/Ag++Manual/Ag++Manual.pdf


%changelog
* Mon Jun 05 2017 daviddavid <daviddavid> 2.2-1.mga6
+ Revision: 1106881
- new version: 2.2
- add upstream patch to fix build with our clang 3.9.1

  + tmb <tmb>
    - rebuild with new llvm

* Wed Jul 13 2016 daviddavid <daviddavid> 2.1-2.mga6
+ Revision: 1041867
- add patch to support also latest llvm/clang 3.8.1

* Mon Jul 11 2016 daviddavid <daviddavid> 2.1-1.mga6
+ Revision: 1041070
- new version: 2.1 (fixes build against llvm/clang 3.8.0)
  * http://www.aspectc.org/bugzilla/show_bug.cgi?id=600
- add provides on puma-devel and aspectc++-devel
- add BR llvm-static

  + tmb <tmb>
    - rebuild for new llvm

  + wally <wally>
    - try to fool build process to support clang 3.8.0

  + tv <tv>
    - rebuild for new llvm

* Mon Feb 22 2016 danf <danf> 2.0-1.mga6
+ Revision: 976187
- Upgraded to ver. 2.0
- Use & package libMiniPuma instead of libPuma
- Using libMiniPuma allows removing the binary bootstrap requirement
- Moved the static library into the -devel package

  + umeabot <umeabot>
    - Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 1.2-4.mga5
+ Revision: 739583
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.2-3.mga5
+ Revision: 677918
- Mageia 5 Mass Rebuild

* Sat Jan 04 2014 pterjan <pterjan> 1.2-2.mga4
+ Revision: 564428
- Disable bootstrap

* Tue Dec 31 2013 danf <danf> 1.2-1.mga4
+ Revision: 563552
- build a new package containing the AspectC++ compiler and use it when
  rebuilding itself (unless bootstrapping)
- renamed libpuma0 to libpuma-static since it only contains a static library
- included PDF documentation in packages
- enabled running test suite at build time
- Upgraded to ver. 1.2
- Added an option to bootstrap the ac++/ag++ binaries from sources instead of
  relying on opaque binary blobs

  + umeabot <umeabot>
    - Mageia 4 Mass Rebuild

* Sun Feb 03 2013 neoclust <neoclust> 1.1-1.mga3
+ Revision: 394174
- Try to fix build on 64bit
- Use a snapshot ( fix gcc build )
- imported package aspectc++

